<div class="full-width overflow-hidden">
  <div class="full-width" style="overflow-x: auto">
    <nz-table
      #smallTable
      nzFrontPagination="false"
      nzSize="small"
      nzBordered
      [nzData]="extendedInventory"
      [attr.data-test-element-id]="'inventory-table'"
    >
      <thead>
        <tr>
          <th scope="col"></th>
          <th scope="colgroup" colspan="3">
            {{
              'sqtm-core.campaign-workspace.iteration-page.statistics.inventory.groups.synthesis'
                | translate
            }}
          </th>
          <th scope="colgroup" [colspan]="progressColSpan">
            {{
              'sqtm-core.campaign-workspace.iteration-page.statistics.inventory.groups.execution'
                | translate
            }}
          </th>
          <th scope="colgroup" colspan="4">
            {{
              'sqtm-core.campaign-workspace.iteration-page.statistics.inventory.groups.never-executed'
                | translate
            }}
          </th>
        </tr>
        <tr>
          <th
            class="font-14-px label-color header"
            scope="col"
            [nzAlign]="'center'"
          >
            {{ 'sqtm-core.entity.test-suite.label.singular' | translate }}
          </th>
          <th
            class="font-14-px label-color header"
            scope="col"
            [nzAlign]="'center'"
          >
            {{
              'sqtm-core.campaign-workspace.iteration-page.statistics.inventory.total'
                | translate
            }}
          </th>
          <th
            class="font-14-px label-color header"
            scope="col"
            [nzAlign]="'center'"
          >
            {{
              'sqtm-core.campaign-workspace.iteration-page.statistics.inventory.to-do'
                | translate
            }}
          </th>
          <th
            class="font-14-px label-color header"
            scope="col"
            [nzAlign]="'center'"
          >
            {{
              'sqtm-core.campaign-workspace.iteration-page.statistics.inventory.done'
                | translate
            }}
          </th>
          <ng-container
            *ngTemplateOutlet="
              header;
              context: { executionStatus: ExecutionStatus.READY }
            "
          ></ng-container>
          <ng-container
            *ngTemplateOutlet="
              headerWithe;
              context: { executionStatus: ExecutionStatus.RUNNING }
            "
          ></ng-container>
          <ng-container
            *ngTemplateOutlet="
              headerWithe;
              context: { executionStatus: ExecutionStatus.SUCCESS }
            "
          ></ng-container>
          @if (settledIsEnabled) {
            <ng-container
              *ngTemplateOutlet="
                header;
                context: { executionStatus: ExecutionStatus.SETTLED }
              "
            ></ng-container>
          }
          <ng-container
            *ngTemplateOutlet="
              headerWithe;
              context: { executionStatus: ExecutionStatus.FAILURE }
            "
          ></ng-container>
          <ng-container
            *ngTemplateOutlet="
              header;
              context: { executionStatus: ExecutionStatus.BLOCKED }
            "
          ></ng-container>
          @if (untestableIsEnabled) {
            <ng-container
              *ngTemplateOutlet="
                headerWithe;
                context: { executionStatus: ExecutionStatus.UNTESTABLE }
              "
            ></ng-container>
          }
          <th
            class="font-14-px label-color header"
            [nzAlign]="'center'"
            scope="col"
            nz-tooltip
            [nzTooltipTitle]="
              'sqtm-core.campaign-workspace.iteration-page.statistics.inventory.prog.tooltip'
                | translate
            "
          >
            {{
              'sqtm-core.campaign-workspace.iteration-page.statistics.inventory.prog.short'
                | translate
            }}
          </th>
          <th
            class="font-14-px label-color header"
            scope="col"
            [nzAlign]="'center'"
          >
            {{
              'sqtm-core.campaign-workspace.iteration-page.statistics.inventory.success'
                | translate
            }}
          </th>
          <th
            class="font-14-px label-color header"
            scope="col"
            [nzAlign]="'center'"
          >
            {{
              'sqtm-core.campaign-workspace.iteration-page.statistics.inventory.failure'
                | translate
            }}
          </th>
          <th
            class="font-14-px label-color header"
            [nzAlign]="'center'"
            scope="col"
            nz-tooltip
            [nzTooltipTitle]="
              'sqtm-core.campaign-workspace.iteration-page.statistics.inventory.prev.tooltip'
                | translate
            "
          >
            {{
              'sqtm-core.campaign-workspace.iteration-page.statistics.inventory.prev.short'
                | translate
            }}
          </th>
          <ng-container
            *ngTemplateOutlet="
              importance;
              context: { testCaseImportance: TestCaseImportance.VERY_HIGH }
            "
          ></ng-container>
          <ng-container
            *ngTemplateOutlet="
              importance;
              context: { testCaseImportance: TestCaseImportance.HIGH }
            "
          ></ng-container>
          <ng-container
            *ngTemplateOutlet="
              importance;
              context: { testCaseImportance: TestCaseImportance.MEDIUM }
            "
          ></ng-container>
          <ng-container
            *ngTemplateOutlet="
              importance;
              context: { testCaseImportance: TestCaseImportance.LOW }
            "
          ></ng-container>
        </tr>
      </thead>
      <tbody>
        @for (data of smallTable.data; track data) {
          <tr [class.resumeRow]="data.isTotal">
            <td [nzAlign]="'center'" [class.no-suite]="!data.testSuiteName">
              {{
                data.testSuiteName ||
                  'sqtm-core.campaign-workspace.iteration-page.statistics.inventory.no-suite'
                  | translate
              }}
            </td>
            <td [nzAlign]="'center'" [attr.data-test-element-id]="'nb-total'">
              {{ data.nbTotal }}
            </td>
            <td
              [nzAlign]="'center'"
              [attr.data-test-element-id]="'nb-to-execute'"
            >
              {{ data.nbToExecute }}
            </td>
            <td
              [nzAlign]="'center'"
              [attr.data-test-element-id]="'nb-executed'"
            >
              {{ data.nbExecuted }}
            </td>
            <ng-container
              *ngTemplateOutlet="
                cell;
                context: { enumValue: ExecutionStatus.READY, data: data }
              "
            ></ng-container>
            <ng-container
              *ngTemplateOutlet="
                cell;
                context: { enumValue: ExecutionStatus.RUNNING, data: data }
              "
            ></ng-container>
            <ng-container
              *ngTemplateOutlet="
                cell;
                context: { enumValue: ExecutionStatus.SUCCESS, data: data }
              "
            ></ng-container>
            @if (
              !disabledExecutionStatus.includes(ExecutionStatus.SETTLED.id)
            ) {
              <ng-container
                *ngTemplateOutlet="
                  cell;
                  context: { enumValue: ExecutionStatus.SETTLED, data: data }
                "
              ></ng-container>
            }
            <ng-container
              *ngTemplateOutlet="
                cell;
                context: { enumValue: ExecutionStatus.FAILURE, data: data }
              "
            ></ng-container>
            <ng-container
              *ngTemplateOutlet="
                cell;
                context: { enumValue: ExecutionStatus.BLOCKED, data: data }
              "
            ></ng-container>
            @if (untestableIsEnabled) {
              <ng-container
                *ngTemplateOutlet="
                  cell;
                  context: { enumValue: ExecutionStatus.UNTESTABLE, data: data }
                "
              ></ng-container>
            }
            <td
              [nzAlign]="'center'"
              [attr.data-test-element-id]="'pc-progress'"
            >
              {{ data.pcProgress }} %
            </td>
            <td [nzAlign]="'center'" [attr.data-test-element-id]="'pc-success'">
              {{ data.pcSuccess }} %
            </td>
            <td [nzAlign]="'center'" [attr.data-test-element-id]="'pc-failure'">
              {{ data.pcFailure }} %
            </td>
            <td
              [nzAlign]="'center'"
              [attr.data-test-element-id]="'pc-prev-progress'"
            >
              {{ data.pcPrevProgress }} %
            </td>
            <ng-container
              *ngTemplateOutlet="
                cell;
                context: { enumValue: TestCaseImportance.VERY_HIGH, data: data }
              "
            ></ng-container>
            <ng-container
              *ngTemplateOutlet="
                cell;
                context: { enumValue: TestCaseImportance.HIGH, data: data }
              "
            ></ng-container>
            <ng-container
              *ngTemplateOutlet="
                cell;
                context: { enumValue: TestCaseImportance.MEDIUM, data: data }
              "
            ></ng-container>
            <ng-container
              *ngTemplateOutlet="
                cell;
                context: { enumValue: TestCaseImportance.LOW, data: data }
              "
            ></ng-container>
          </tr>
        }
      </tbody>
    </nz-table>
  </div>
</div>

<ng-template #header let-executionStatus="executionStatus">
  <th
    scope="col"
    [style.backgroundColor]="executionStatus.color"
    [nzAlign]="'center'"
    class="font-14-px label-color header"
  >
    {{ executionStatus.i18nKey | translate }}
  </th>
</ng-template>

<ng-template #headerWithe let-executionStatus="executionStatus">
  <th
    scope="col"
    [style.backgroundColor]="executionStatus.color"
    [nzAlign]="'center'"
    [style.color]="'white'"
    class="font-14-px header"
  >
    {{ executionStatus.i18nKey | translate }}
  </th>
</ng-template>

<ng-template #importance let-testCaseImportance="testCaseImportance">
  <th scope="col" [nzAlign]="'center'" class="font-14-px header">
    <sqtm-core-i18n-enum-icon
      [i18nEnumItem]="testCaseImportance"
      [i18nEnum]="TestCaseImportance"
    ></sqtm-core-i18n-enum-icon>
  </th>
</ng-template>

<ng-template #cell let-enumValue="enumValue" let-data="data">
  <td [attr.data-test-element-id]="enumValue.id" [nzAlign]="'center'">
    {{ data[enumValue.id] }}
  </td>
</ng-template>
